/**
 * @author Christian Burger (christian@krikkel.de)
 */

#include <NCursesPtyWindow/Window.hpp>

namespace krikkel::NCursesPtyWindow
{
    Window::Window(int lines, int columns, int y, int x)
            : NCursesWindow(lines, columns, y, x)
    {}

    int Window::addnwstr(const wchar_t *wstr, int n)
    {
        return ::waddnwstr(w, wstr, n);
    }

    int Window::add_wch(const cchar_t *character)
    {
        return ::wadd_wch(w, character);
    }

    int Window::ins_wch(const cchar_t *character)
    {
        return ::wins_wch(w, character);
    }

    int Window::get_wch(wint_t *character)
    {
        return ::wget_wch(w, character);
    }

    SingleUserInput Window::readSingleUserInput()
    {
        wint_t input;
        int result = get_wch(&input);
        return SingleUserInput(result, input);
    }

}